#	include	"Standard.h"

bool
BoundedChannel	::	Insert ( Message * aMessage,
						   int aLatency)
	{
	int             Latency;

	if ( GetDomain()->GetCurrentCycle() == CountingCycle )
		{
		if ( InsertLimit != UNLIMITED && InsertedThisCycle >= InsertLimit )
			{
			return false;
			}
		}
	else
		{
		CountingCycle = GetDomain()->GetCurrentCycle();
		InsertedThisCycle = 0;
		RemovedThisCycle = 0;
		}

	if ( MaxOccupancy != UNLIMITED && Messages.GetSize () >= MaxOccupancy )
		{
		return false;
		}

	if ( EnforceFixedLatency || aLatency == -1 )
		{
		Latency = FixedLatency;
		}
	else
		{
		Latency = aLatency;
		}

	InsertedThisCycle++;

	GetDomain()->MessageChannelIsLive ( this, GetDomain()->GetCurrentCycle() + Latency );
	Messages.Push ( aMessage, GetDomain()->GetCurrentCycle() + Latency );
	return true;
	}

int
BoundedChannel	::	FreeSpace (  )
	{

	int             InsertLimitSlack;
	int             OccupancySlack;

	if ( GetDomain()->GetCurrentCycle() == CountingCycle )
		{
		if ( InsertLimit != UNLIMITED && InsertedThisCycle >= InsertLimit )
			{
			InsertLimitSlack = 0;
			}
		else
			{
			if ( InsertLimit == UNLIMITED )
				{
				InsertLimitSlack = 0x7fffffff;
				}
			else
				{
				InsertLimitSlack = InsertLimit - InsertedThisCycle;
				}
			}
		}
	else
		{
		CountingCycle = InDomain->GetCurrentCycle();
		InsertedThisCycle = 0;
		InsertLimitSlack = InsertLimit;
		}

	if ( MaxOccupancy != UNLIMITED && Messages.GetSize (  ) >= MaxOccupancy )
		{
		OccupancySlack = 0;
		}
	else
		{
		if ( MaxOccupancy == UNLIMITED )
			{
			OccupancySlack = 0x7fffffff;
			}
		else
			{
			OccupancySlack = MaxOccupancy - Messages.GetSize (  );
			}
		}

	return OccupancySlack < InsertLimitSlack ? OccupancySlack : InsertLimitSlack;

	}

void
BoundedChannel	::	Deliver (  )
	{
	Message        *m;
#ifdef	ENABLE_LIBRARY_CHECKS
	assert( GetDomain() != NULL );
	assert( GetInputPort() != NULL );
#endif
	if ( InDomain->GetCurrentCycle() == CountingCycle )
		{
		if ( RemoveLimit != UNLIMITED && RemovedThisCycle >= RemoveLimit )
			return;
		}
	else
		{
		CountingCycle = GetDomain()->GetCurrentCycle();
		InsertedThisCycle = 0;
		RemovedThisCycle = 0;
		}
	bool	Delivered = false;

	while ( (RemoveLimit == UNLIMITED || RemovedThisCycle < RemoveLimit) &&
		((m = Messages.Peek(CountingCycle)) != NULL) )
		{
		if(GetInputPort()->WhenCanYouTakeThisMessage(m, NULL) )
			{
			if ( GetDomain()->TotalEffect )
				{
				Slack.Push(m);
				Messages.Pop(CountingCycle);
				continue;
				}
			else
				break;
			}

		if(!GetInputPort()->ReceiveMessage(m))
			{
			if ( GetDomain()->TotalEffect )
				{
				Slack.Push(m);
				Messages.Pop(CountingCycle);
				continue;
				}
			else
				break;
			}

		Messages.Pop(CountingCycle);
		Delivered = true;
		++RemovedThisCycle;
		}
	while ( Slack.GetSize() )
		{
		Slack.Pop(m);
		Messages.Push(m, CountingCycle);
		}

	// call us back on the next cycle if there is more stuff to do...
	if ( Messages.Peek(CountingCycle) )
		{
		if ( Delivered && GetDomain()->TotalEffect )
			GetDomain()->MessageChannelIsLive ( this, CountingCycle + 0);
		else
			GetDomain()->MessageChannelIsLive ( this, CountingCycle + 1);
		}
	}

