
class	BoundedChannel	:
	public	MessageChannel
	{
	public:
		static const int UNLIMITED = -1;

	private:
		uint64			CountingCycle;
		int				InsertLimit;
		int				RemoveLimit;

		int				InsertedThisCycle;
		int				RemovedThisCycle;
		int				FixedLatency;
		int				MaxOccupancy;

		bool			EnforceFixedLatency;

		ScheduledQueue < Message * >	Messages;
		Stack < Message * >				Slack;

	public:
		virtual ~ BoundedChannel () {};
		bool	Initialize( 	int		aInsertLimit,
								int		aMaxOccupancy,
								int		aRemoveLimit,
								int		aFixedLatency,
								bool	aEnforceFixedLatency )
			{
			InsertLimit = aInsertLimit;
			RemoveLimit = aRemoveLimit;
			FixedLatency = aFixedLatency;
			EnforceFixedLatency = aEnforceFixedLatency;
			MaxOccupancy = aMaxOccupancy;

			InsertedThisCycle = 0;
			RemovedThisCycle = 0;
			CountingCycle = 0;
			return(true);
			}

		bool	Insert ( Message * Message, int aLatency = -1 );
		int		FreeSpace (  );
		inline	int	GetSize (  ) { return Messages.GetSize (  ); }
		void	Deliver (  );
	};

