#	include	"Standard.h"


bool
SimpleChannel	::	Insert ( Message * aMessage,
						  int Latency )
	{
#ifdef	ENABLE_LIBRARY_CHECKS
	assert( GetDomain() != NULL );
#endif
	GetDomain()->MessageChannelIsLive ( this, GetDomain()->GetCurrentCycle() + Latency );
	Messages.Push ( aMessage, GetDomain()->GetCurrentCycle() + Latency );
	return true;
	}

void
SimpleChannel	::	Deliver ()
	{
	Message        *m;
#ifdef	ENABLE_LIBRARY_CHECKS
	assert( GetDomain() != NULL );
	assert( GetInputPort() != NULL );
#endif
	bool	Delivered = false;

	while ( ((m = Messages.Peek(GetDomain()->GetCurrentCycle())) != NULL) )
		{
		if(GetInputPort()->WhenCanYouTakeThisMessage(m, NULL) )
			{
			if ( GetDomain()->TotalEffect )
				{
				Slack.Push(m);
				Messages.Pop(GetDomain()->GetCurrentCycle());
				continue;
				}
			else
				break;
			}

		if(!GetInputPort()->ReceiveMessage(m))
			{
			if ( GetDomain()->TotalEffect )
				{
				Slack.Push(m);
				Messages.Pop(GetDomain()->GetCurrentCycle());
				continue;
				}
			else
				break;
			}

		Messages.Pop(GetDomain()->GetCurrentCycle());
		Delivered = true;
		}
	while ( Slack.GetSize() )
		{
		Slack.Pop(m);
		Messages.Push(m, GetDomain()->GetCurrentCycle());
		}

	// call us back on the next cycle if there is more stuff to do...
	if ( Messages.Peek(GetDomain()->GetCurrentCycle()))
		{
		if ( Delivered && GetDomain()->TotalEffect )
			GetDomain()->MessageChannelIsLive ( this, GetDomain()->GetCurrentCycle() + 0);
		else
			GetDomain()->MessageChannelIsLive ( this, GetDomain()->GetCurrentCycle() + 1);
		}
	}

