#	include	"Standard.h"

int	Component	::	MasterId	=	1;

Component	::	Component(
	char	*theName)
	{
	Name = NULL;
	if(theName)
		SetName(theName);
	InDomain = NULL;
	Id = MasterId++;
	}

Component	::	~Component()
	{
	SetName(NULL);
	}

bool
Component	::	SetName(
	char	*NewName)
	{
	if(Name)
		delete Name;
	Name = NULL;
	if(NewName)
		{
		Name = new char[strlen(NewName)+1];
		strcpy(Name, NewName);
		}
	return(true);
	}

char	*
Component	::	GetName()
	{
	if(Name)
		return(Name);
	return("No Name");
	}

bool
Component	::	PrintValueFirstPart(
	OutputFormat		Format,
	FILE	*fp,
	char	*StatName)
	{

	if(Format==HumanFormat)
		{
		char	Name[1024];
		sprintf(Name, "%s.%s", GetName(), StatName);
		fprintf(fp, "#  %-79s:", Name);
		}
	else
	if(Format==MachineFormat)
		{
		fprintf(fp, "%s.%s ", GetName(), StatName);
		}
	return(true);
	}

bool
Component	::	PrintValueLastPart(
	OutputFormat		Format,
	FILE	*fp)
	{
	if(Format==HumanFormat)
		{
		fprintf(fp, "\n");
		}
	else
	if(Format==MachineFormat)
		{
		fprintf(fp, " ");
		}
	return(true);
	}

bool
Component	::	PrintPercent(
	OutputFormat		Format,
	FILE	*fp,
	char	*StatName,
	Counter	InValue,
	Counter	OutValue)
	{
	PrintValueFirstPart(Format, fp, StatName);
	fprintf(fp, "%.2f%%", (100.0*(double)InValue)/((double)(InValue+OutValue)));
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	OutputFormat		Format,
	FILE	*fp,
	char	*StatName,
	Counter	Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	if ( (Format == HumanFormatHex) || (Format == MachineFormatHex) )
		fprintf(fp, "0x" format_hex_uint64 "", Value);
	else
		fprintf(fp, "" format_dec_int64 "", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	OutputFormat		Format,
	FILE	*fp,
	char	*StatName,
	int		Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	if ( (Format == HumanFormatHex) || (Format == MachineFormatHex) )
		fprintf(fp, "0x%x", Value);
	else
		fprintf(fp, "%d", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	OutputFormat		Format,
	FILE	*fp,
	char	*StatName,
	double	Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	fprintf(fp, "%.2f", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	OutputFormat		Format,
	FILE	*fp,
	char	*StatName,
	uint	Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	if ( (Format == HumanFormatHex) || (Format == MachineFormatHex) )
		fprintf(fp, "0x%x", Value);
	else
		fprintf(fp, "%u", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}
/*
bool
Component	::	PrintValue(
	OutputFormat		Format,
	FILE	*fp,
	char	*StatName,
	uint32	Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	if ( (Format == HumanFormatHex) || (Format == MachineFormatHex) )
		fprintf(fp, "0x%8.8x", Value);
	else
		fprintf(fp, "%u", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	OutputFormat		Format,
	FILE	*fp,
	char	*StatName,
	uint64	Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	if ( (Format == HumanFormatHex) || (Format == MachineFormatHex) )
		fprintf(fp, "0x" format_hex_uint64 "", Value);
	else
		fprintf(fp, "" format_dec_int64 "", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}
*/

bool
Component	::	Join(
	Domain	*d)
	{
	d->AddComponent(this);
	for(int	Index = 0; Index < Members.GetSize(); Index++)
		Members[Index]->Join(d);
	InDomain = d;
	return ( true );
	}

bool
Component	::	ResetStatistics()
	{
	int	Index = 0;
	while ( Index < Members.GetSize())
		{
		Members[Index]->ResetStatistics();
		++Index;
		}
	return(true);
	}

