enum	OutputFormat
	{
	HumanFormat	=	1,
	HumanFormatHex,
	MachineFormat,
	MachineFormatHex
	};

class	Domain;
class	Message;

class	Component
	{
	public:
		char				*Name;
		Component			*Owner;
		Array<Component *>	Members;
		Domain				*InDomain;
		static	int			MasterId;
		int					Id;
	public:
				Component(char	*Name = NULL);
		virtual	~Component();

		bool		SetName(char	*s);
		char		*GetName();
		int			GetId()	{	return(Id);	}
		bool		SetOwner(Component	*x = NULL)	{ Owner = x; return(true); }
		Component	*GetOwner()						{ return ( Owner ); }
		Domain		*GetDomain()					{ return ( InDomain ); }
		bool		AddComponent(Component *x = NULL)	{ Members.Add(x); return(true); }
		virtual	bool	Join(Domain *d);
		virtual	bool	IsMessageChannel()			{	return(false);	}
		virtual	bool	SendMessage(Component *c, Message	*m)		{	return ( c->ReceiveMessage(this, m) ); }
		virtual	bool	ReceiveMessage(Component *f, Message	*m)	{	FatalError("This component cannot ReceiveMessage"); return(false); }
		virtual	int		WhenCanYouTakeThisMessage(Component *, Message	*m)	{	return(0 /* now */);	}
		virtual	bool	Create()	{	return(true);	}
	public:
		virtual	int		SimulateOneCycle() { return ( -1 ); }
		virtual	int		AsyncSimulateOneCycle() { return ( -1 ); }
		virtual	int		SyncSimulateOneCycle() { return ( -1 ); }
		virtual	bool	PrintPercent(OutputFormat, FILE *, char *, Counter, Counter);
		virtual	bool	PrintValue(OutputFormat, FILE *, char *, Counter);
		virtual	bool	PrintValue(OutputFormat, FILE *, char *, int);
//		virtual	bool	PrintValue(OutputFormat, FILE *, char *, uint);
		virtual	bool	PrintValue(OutputFormat, FILE *, char *, uint32);
		virtual	bool	PrintValue(OutputFormat, FILE *, char *, double);
//		virtual	bool	PrintValue(OutputFormat, FILE *, char *, uint64);
		virtual	bool	PrintStatistics(
					OutputFormat	Format = HumanFormat,
					FILE	*fp = stdout)
			{	return(true); }
		virtual	bool	PrintConfiguration(
					OutputFormat	Format = HumanFormat,
					FILE	*fp = stdout)
			{	return(true); }
		virtual	bool	ResetStatistics();
	protected:
		virtual	bool	PrintValueFirstPart(OutputFormat, FILE *, char *);
		virtual	bool	PrintValueLastPart(OutputFormat, FILE *);
	};

#	define	NameByPtr(xxx)	xxx->SetName(#xxx)
