class	MessageChannel;

enum	SimulationMode
	{
	FastForwarding = 1,
	WarmingUp,
	Simulating
	};

class	Domain	:
	public	Component
	{
	public:

		Array <Component *>					Components;
		Array <MessageChannel *>			Channels;
		ScheduledQueue<MessageChannel *>	LiveChannels;
		ScheduledQueue<Component *>			LiveComponents;
     	Array <Component	*>				SimulateComponents;
     	Array <Component	*>				SyncSimulateComponents;
		uint64								CurrentCycle;
		uint64								StatCurrentCycle;
		bool								TotalEffect;
		SimulationMode						theCurrentMode;
	public:     

     
				Domain(char *aName = NULL)
			{
			SetName(aName);
			CurrentCycle = 0;
			StatCurrentCycle = 0;
			}
				~Domain(){}
		SimulationMode	GetSimulationMode() { return (theCurrentMode); }
		bool			SetSimulationMode(SimulationMode s) { theCurrentMode = s; return(true); }
		uint64			GetCurrentCycle() { return(CurrentCycle); }
		uint64			GetStatCurrentCycle() { return(StatCurrentCycle); }

		static	bool	BindParameters(Domain	*This, TupleSpace	*theTupleSpace, char *aName = NULL);
		
		inline	int		CountLiveChannel() { return LiveChannels.GetSize();}
		inline	int		CountLiveComponent() { return LiveComponents.GetSize();}
		void			AddComponent(Component * aComponent);
		void			AddChannel(MessageChannel *aChannel);
		inline	void	MessageChannelIsLive(MessageChannel *c, uint64	ReadyCycle) { LiveChannels.Push(c, ReadyCycle); }
		inline	void	ComponentIsLive(Component *c, uint64	ReadyCycle) { if ( TotalEffect ) LiveComponents.Push(c, ReadyCycle); }
		int				AsyncSimulateOneCycle();

		bool			ResetStatistics();
	};

