class	Port	:
	public	Component
	{
	public:
		Array < MessageChannel	*	>	ConnectedChannels;
		Array < Component	*		>	ConnectedComponents;

		bool	Connect(MessageChannel	*mc)			{	ConnectedChannels.Add(mc);		return(true); }
		bool	Connect(Component		*mc)			{	ConnectedComponents.Add(mc);	return(true); }
		virtual	bool	ReceiveMessage(Message	*, Port	* = NULL)	{	return(false);	}
		virtual	bool	SendMessage(Message	*, Port	* = NULL)		{	return(false);	}
	};

class	InputPort	:
	public	Port
	{
	public:
		virtual	int		WhenCanYouTakeMessage(Message	*m, Port	*p)
			{
#	ifdef	ENABLE_LIBRARY_CHECKS
			if(!ConnectedComponents.GetSize())
				{
				fprintf(stdout, "Oddly, %s::ReceiveMessage invoked but no channel is connected\n", GetName());
				FatalError("This should be a fatal error");
				return(false);
				}
#	endif
			int	Max = -1;
		
			for(int Index=0;Index<ConnectedComponents.GetSize();Index++)
				{
				if ( m->GetSourceComponentId() != ConnectedComponents[Index]->GetId() )
					{
					int	TempMax = ConnectedComponents[Index]->WhenCanYouTakeThisMessage(m, this);
					if ( TempMax > Max )
						Max = TempMax;
					}
				}
			if ( Max < 0 )
				Max = 0;
			return ( Max );
			}
		virtual	bool	ReceiveMessage(Message	*m, Port *p= NULL)
			{
#	ifdef	ENABLE_LIBRARY_CHECKS
			if(!ConnectedComponents.GetSize())
				{
				fprintf(stdout, "Oddly, %s::ReceiveMessage invoked but no channel is connected\n", GetName());
				FatalError("This should be a fatal error");
				return(false);
				}
#	endif
			// optimize for the comment case
			if ( ConnectedComponents.GetSize() == 1 )
				{
				if ( m->GetSourceComponentId() == ConnectedComponents[0]->GetId() )
					{
					delete m;
					return(true);
					}
				if(!ConnectedComponents[0]->ReceiveMessage(m,this))
					return(false);
				ConnectedComponents[0]->AsyncSimulateOneCycle();
				return(true);
				}
			// optimize for the comment case
			if ( ConnectedComponents.GetSize() == 2 )
				{
				if ( m->GetSourceComponentId() == ConnectedComponents[0]->GetId() )
					{
					if(!ConnectedComponents[1]->ReceiveMessage(m,this))
						return(false);
					ConnectedComponents[1]->AsyncSimulateOneCycle();
					return(true);
					}
				else
					{
					if(!ConnectedComponents[0]->ReceiveMessage(m,this))
						return(false);
					ConnectedComponents[0]->AsyncSimulateOneCycle();
					return(true);
					}
				}

			// handle everything else
			for(int Index=1;Index<ConnectedComponents.GetSize();Index++)
				{
				if ( m->GetSourceComponentId() != ConnectedComponents[Index]->GetId() )
				if(!ConnectedComponents[Index]->ReceiveMessage(m->Clone(), this))
					return(false);
				}
			if ( m->GetSourceComponentId() != ConnectedComponents[0]->GetId() )
				{
				if(!ConnectedComponents[0]->ReceiveMessage(m,this))
					return(false);
				}
			else
				delete	m;

			//for(int Index=0;Index<ConnectedComponents.GetSize();Index++)
			//	ConnectedComponents[Index]->AsyncSimulateOneCycle();

			return(true);
			}
	};

class	OutputPort	:
	public	Port
	{
	public:
		virtual	bool	SendMessage(Message	*m, Port *p = NULL)
			{
#	ifdef	ENABLE_LIBRARY_CHECKS
			if(!ConnectedChannels.GetSize())
				{
				fprintf(stdout, "Oddly, %s::SendMessage invoked but no channel is connected\n", GetName());
				FatalError("This should be a fatal error");
				return(false);
				}
#	endif

			// optimize for the comment case
			if ( ConnectedChannels.GetSize() == 1 )
				{
				if(!ConnectedChannels[0]->SendMessage(m,this))
					return(false);
				return(true);
				}
			for(int Index=1;Index<ConnectedChannels.GetSize();Index++)
				if(!ConnectedChannels[Index]->SendMessage(m->Clone(), this))
					return(false);
			if(!ConnectedChannels[0]->SendMessage(m,this))
				return(false);

			return(true);
			}
	};
