// A ResourceLock encapsulates basic exclusion principles.  Multiple entities can
// compete for the "resource", and control can be mitigated through a ResourceLock.
class	ResourceLock
	{
	public:
		uint64	UsedUntil;

			ResourceLock()	{ UsedUntil = 0; };

		bool	Acquire(uint64	CurrentCycle, uint64	HowLong = 1, uint64	*TryAgainAt = NULL)
			{
			if ( UsedUntil <= CurrentCycle )
				{
				UsedUntil = CurrentCycle + HowLong;
				if(!HowLong)
					UsedUntil = (cuint64(0xffffffff)<<32)|cuint64(0xffffffff);
				return(true);
				}
			if(TryAgainAt)
				(*TryAgainAt) = UsedUntil;
			return(false);
			}
		bool	PeekAt(uint64	AtCycle)
			{
			if ( UsedUntil <= AtCycle )
				return(true);
			return(false);
			}
		bool	Free()	// optional
			{
			UsedUntil = 0;
			return(true);
			}
	
	};
