enum	MemoryTransaction
	{
	NoTransaction	=	0,
	Read,
	ReadResponse,
	Write,
	Cancel
	};

class	MemoryTransactionMessage	:
	public	Message
	{
	public:
		uint64				Address;
		MemoryTransaction	Command;
		int					Width;
		uint64				Id;
		uint64				Id2;
		uint64				Id3;
		bool				Speculative;	// speculative request?
		Component			*GoingTo;

		MemoryTransactionMessage	*Clone()
			{
			MemoryTransactionMessage	*mtm = NEW(MemoryTransactionMessage);
			mtm->Address = Address;
			mtm->Command = Command;
			mtm->Width = Width;
			mtm->Id = Id;
			mtm->Id2 = Id2;
			mtm->Id3 = Id3;
			mtm->Speculative = Speculative;
			mtm->SourceComponentId = SourceComponentId;
			mtm->MessageId = MessageId;
			return(mtm);
			}
		uint64				Indexer()	{	return(Id);	}

		bool				Dump(FILE	*);
	};

bool	inline	operator	==	(MemoryTransactionMessage	&mtm1, MemoryTransactionMessage	&mtm2) { return(mtm1.Id == mtm2.Id); }
bool	inline	operator	<	(MemoryTransactionMessage	&mtm1, MemoryTransactionMessage	&mtm2) { return(mtm1.Id < mtm2.Id); }
bool	inline	operator	>	(MemoryTransactionMessage	&mtm1, MemoryTransactionMessage	&mtm2) { return(mtm1.Id > mtm2.Id); }

