// Caches can be used all over the place, and its nice to abstract
// the control logic for them away and put them in a general
// module.  This is that module.

enum	ReplacementPolicy
	{
	LRU	=	1,
	Random
	};

template	<class	T>
class	Line
	{
	public:
		uint64				RealAddress;
		bool				Dirty;
		bool				Valid;
		int					PolicyField;
		int					SharedField;
		T					theObject;
	};

template	<class	T>
class	Bank
	{
	public:
		unsigned	int	NumberOfCacheLines;
		Line<T>		*CacheLines;
	};

template	<class	T>
class	SetAssociativeMemory
	{
	public:
		Bank<T>		*CacheBanks;
		unsigned	int	NumberOfCacheBanks;	
		ReplacementPolicy	theReplacementPolicy;
		Counter			Hits;
		Counter			Misses;
		Counter			WriteBacks;
		unsigned	int	ShiftAmount;
		unsigned	int	EntryMask;
		unsigned	int	LineSize;
		unsigned	int	LastBankAccess;
	public:
		static	SetAssociativeMemory	*Create(
				uint	LineSize,
				uint	BankSize,
				uint	Assoc,
				ReplacementPolicy	Policy);
		void	UpdatePolicy(
				int		Bank,
				uint	Entry);
		Line<T>	*Locate(
				uint64	aAddress,
				uint	*HitOrMiss,
				uint	*ForcedWriteBack,
				Line<T>	*WrittenCacheLine);
		Line<T>	*IsInCache(uint64	aAddress);

	};


