class	SimpleCache	:
	public	Component
	{
	public:
		int			Latency;
		int			MaxOutstandingRequests;
		int			LineSize;
		int			BankSize;
		int			Associativity;
		int			ConcurrentRequests;
		bool		WriteThrough;

		uint64		Hits;
		uint64		Misses;
		uint64		WriteBacks;

		int			RequestsInFlight;
		uint64		FillRequestId;

		OutputPort	*theAccessOutputPort;
		InputPort	*theAccessInputPort;
		OutputPort	*theFillOutputPort;
		InputPort	*theFillInputPort;

		SetAssociativeMemory<int>					*theCache;
		
		Fifo<MemoryTransactionMessage	*>			Overflow;
		ScheduledQueue<MemoryTransactionMessage	*>	ProcessedEvents;
		Fifo<MemoryTransactionMessage	*>			ToFill;
		Fifo<MemoryTransactionMessage	*>			ToAccess;
		Array<MemoryTransactionMessage	*>			PendingMisses;

		static	bool	BindParameters(SimpleCache	*This, TupleSpace	*theTupleSpace,	char	*aName = NULL);

		bool		BindStructures(
			InputPort	*aAccessInputPort,
			OutputPort	*aAccessOutputPort,
			InputPort	*aFillInputPort,
			OutputPort	*aFillOutputPort);

		bool		ReceiveMessage(Message	*m, Port	*p);
		int			WhenCanYouTakeThisMessage(Message *, Port *);

		int			AsyncSimulateOneCycle();
		bool		ResetStatistics();

		bool		PrintStatistics(OutputFormat, FILE *);

	};

