class	SimpleCacheMemorySystem	:
	public	Component
	{
	public:
		SimpleClockedMemoryBus	*L2ToSDRAMBus;
		InputPort				*L2ToSDRAMInputPort;
		OutputPort				*L2ToSDRAMOutputPort;

		SimpleClockedMemoryBus	*L1ToL2Bus;
		InputPort				*L1ToL2InputPort;
		OutputPort				*L1ToL2OutputPort;

		SimpleClockedMemoryBus	*L1InstructionToProcessorBus;
		InputPort				*L1InstructionToProcessorInputPort;
		OutputPort				*L1InstructionToProcessorOutputPort;
		SimpleClockedMemoryBus	*ProcessorToL1InstructionBus;
		InputPort				*ProcessorToL1InstructionInputPort;
		OutputPort				*ProcessorToL1InstructionOutputPort;

		SimpleClockedMemoryBus	*L1DataToProcessorBus;
		InputPort				*L1DataToProcessorInputPort;
		OutputPort				*L1DataToProcessorOutputPort;
		SimpleClockedMemoryBus	*ProcessorToL1DataBus;
		InputPort				*ProcessorToL1DataInputPort;
		OutputPort				*ProcessorToL1DataOutputPort;


		SimpleSDRAMModel		*SDRAMModel;
		SimpleCache				*L2Cache;
		SimpleCache				*L1InstructionCache;
		SimpleCache				*L1DataCache;

		static	bool	BindParameters(SimpleCacheMemorySystem	*This, TupleSpace	*theTupleSpace, char	*aName = NULL );

				bool	Create();

				bool	BindStructures(TupleSpace	*theTupleSpace);

				bool	PrintStatistics(OutputFormat, FILE *);

		InputPort		*GetInputDataPort()			{	return(L1DataToProcessorBus->GetInputPort());	}
		OutputPort		*GetOutputDataPort()		{	return(ProcessorToL1DataBus->GetOutputPort());	}
		InputPort		*GetInputInstructionPort()	{	return(L1InstructionToProcessorBus->GetInputPort());	}
		OutputPort		*GetOutputInstructionPort()	{	return(ProcessorToL1InstructionBus->GetOutputPort());	}
	};

