class	BranchTargetBuffer	:
	public	Component
	{
	public:
		uint64				CorrectPredictions;
		uint64				IncorrectPredictions;
	public:
		virtual	uint64		AccessBranchTargetBuffer(uint64	BranchPC, Instruction	*theInstruction)	{return(0);}
		virtual	bool		UpdateBranchTargetBuffer(uint64	BranchPC, uint64	TargetPC, Instruction	*theInstruction)	{return(true);}
		virtual	bool		PrintStatistics(OutputFormat, FILE *);
				bool		ResetStatistics();
	};

class	SimpleBranchTargetBuffer	:
	public	BranchTargetBuffer
	{
	public:
		uint64		*PredictedPCTable;

		int			TableSize;
		int			ShiftRight;
		int			Mask;

		static	bool	BindParameters(SimpleBranchTargetBuffer	*This, TupleSpace	*theTupleSpace);
		bool			BindStructures();

		uint64		AccessBranchTargetBuffer(uint64	BranchPC, Instruction	*theInstruction);
		bool		UpdateBranchTargetBuffer(uint64	BranchPC, uint64	TargetPC, Instruction	*theInstruction);
	};

class	SetAssociativeBranchTargetBuffer	:
	public	BranchTargetBuffer
	{
	public:

		SetAssociativeMemory<uint64>	*theMemory;

		int			Associativity;
		int			BankSize;

		uint64		*ReturnAddressStack;
		int			ReturnAddressStackSize;
		int			ReturnAddressStackCurrentSize;
		int			ReturnAddressStackPointer;

		static	bool	BindParameters(SetAssociativeBranchTargetBuffer	*This, TupleSpace	*theTupleSpace);
		bool			BindStructures();

		uint64		AccessBranchTargetBuffer(uint64	BranchPC, Instruction	*theInstruction);
		bool		UpdateBranchTargetBuffer(uint64	BranchPC, uint64	TargetPC, Instruction	*theInstruction);
	};


