// The completion stage "completes" instructions.  Note: this largely does
// nothing.  If InOrder is set then it will keep instructions around until it
// can retire them in order.  One thing it does do is discover mis-speculations.
// On such it will notifty the world

class	CompletionStage	:
	public	ProcessorStage
	{
	public:
		Array<Instruction	*>	CompletionBuffer;
		uint64					SequenceNumber;
		int						CompletionBufferSize;
		int						MaximumDispatchesPerCycle;
		int						MaximumCompletionsPerCycle;	
		int						DispatchesThisCycle;
		int						CompletionsThisCycle;
		FetchStage				*theFetchStage;
		RenameStage				*theRenameStage;
		int						nscSequenceNumber;

		uint64					RetiredInstructions[TotalOps];

		virtual		~CompletionStage() {};

		static	bool	BindParameters(CompletionStage	*This, TupleSpace	*theTupleSpace, char	*aName = NULL);

		bool		BindStructures(FetchStage	*aFetchStage, RenameStage	*theRenameStage);

		bool		DispatchTo(Instruction	*);
		bool		ReserveSpaceFor(Instruction	*);
		int			SimulateOneCycle();

		bool		FlushSpeculativeState();
		bool		EnterSpeculativeState(uint64	MisSpeculatedInstruction);
	
		bool		PrintDebuggingInformation(FILE	*fp, int	Level);

		bool		PrintStatistics(OutputFormat, FILE *);

		bool		ResetStatistics();
	};
	
