#	include	"Standard.h"

bool
Debugger	::	PrintDependencies(
	int	Indent,
	Instruction	*theInstruction,
	FetchStage	*theFetchStage,
	RenameStage	*theRenameStage)
	{
	FILE	*fp = stdout;
	if(!theInstruction)
		{
		fprintf(fp, "?\n");
		return(false);
		}
	if(Indent>32)
		return(false);
	if(theInstruction->Executed)
		{
		return(true);
		}
	if(theInstruction->MemoryExecuted)
		{
		return(true);
		}
	if(!theRenameStage->IsRegisterValid(theInstruction->Input1))
		{
		Instruction	*theInstruction2;
		for(int Index=0;Index<Indent;Index++)	fprintf(fp, " ");
		fprintf(fp, "wo: ");
		Debugger::DumpInstruction(theInstruction2 = theFetchStage->LocateProducerInstruction(theInstruction->Input1), theRenameStage);
		PrintDependencies(Indent + 2, theInstruction2, theFetchStage, theRenameStage);
		}
	if(!theRenameStage->IsRegisterValid(theInstruction->Input2))
		{
		Instruction	*theInstruction2;
		for(int Index=0;Index<Indent;Index++)	fprintf(fp, " ");
		fprintf(fp, "wo: ");
		Debugger::DumpInstruction(theInstruction2 = theFetchStage->LocateProducerInstruction(theInstruction->Input2), theRenameStage);
		PrintDependencies(Indent + 2, theInstruction2, theFetchStage, theRenameStage);
		}
	if(!theRenameStage->IsRegisterValid(theInstruction->Input3))
		{
		Instruction	*theInstruction2;
		for(int Index=0;Index<Indent;Index++)	fprintf(fp, " ");
		fprintf(fp, "wo: ");
		Debugger::DumpInstruction(theInstruction2 = theFetchStage->LocateProducerInstruction(theInstruction->Input3), theRenameStage);
		PrintDependencies(Indent + 2, theInstruction2, theFetchStage, theRenameStage);
		}
	return(true);
	}

bool
Debugger	::	DumpInstruction(
	Instruction	*theInstruction,
	RenameStage	*theRenameStage)
	{
	if ( ! theInstruction)
		{
		printf("null ?\n");
		return(false);
		}
	printf("[" format_dec_int64 "," format_dec_int64 "] ",theInstruction->Sequence, theInstruction->LoadStoreSequence);
	switch(theInstruction->Operation)
		{
		case	OpUnknown:		printf("unkown  ");break;
		case	OpInteger:		printf("integer ");break;
		case	OpFloatingPoint:printf("floatpt ");break;
		case	OpLoad:			printf("load    ");break;
		case	OpStore:		printf("store   ");break;
		case	OpBranch:		printf("branch  ");break;
		case	OpIndirectBranch:printf("ibranch ");break;
		case	OpSystem:		printf("system  ");break;
		}
	printf("(");
	if ( theInstruction->Output1 == NoRegister )
		printf("*, ");
	else
		printf("%d, ", theInstruction->Output1);

	if ( theInstruction->Output2 == NoRegister )
		printf("*) <- (");
	else
		printf("%d) <- (", theInstruction->Output2);

	if ( theInstruction->Input1 == NoRegister )
		printf("*, ");
	else
		printf("%d, ", theInstruction->Input1);

	if ( theInstruction->Input2 == NoRegister )
		printf("*, ");
	else
		printf("%d, ", theInstruction->Input2);

	if ( theInstruction->Input3 == NoRegister )
		printf("*) : ");
	else
		printf("%d) : ", theInstruction->Input3);

	// replaced by the mess up above
	//printf("(%d, %d) <- ", theInstruction->Output1, theInstruction->Output2);
	//printf("(%d, %d, %d) : ", theInstruction->Input1, theInstruction->Input2, theInstruction->Input3);

	if ( theRenameStage )
		{
		printf("(%d, %d) <- (%d, %d, %d) : ",
		theRenameStage->IsRegisterValid(theInstruction->Output1),
		theRenameStage->IsRegisterValid(theInstruction->Output2),
		theRenameStage->IsRegisterValid(theInstruction->Input1),
		theRenameStage->IsRegisterValid(theInstruction->Input2),
		theRenameStage->IsRegisterValid(theInstruction->Input3)
			);
		}
	printf("<");
	if ( theInstruction->rOutput1 == NoRegister )
		printf("*, ");
	else
		printf("%d, ", theInstruction->rOutput1);

	if ( theInstruction->rOutput2 == NoRegister )
		printf("*> <- <");
	else
		printf("%d> <- <", theInstruction->rOutput2);

	if ( theInstruction->rInput1 == NoRegister )
		printf("*, ");
	else
		printf("%d, ", theInstruction->rInput1);

	if ( theInstruction->rInput2 == NoRegister )
		printf("*, ");
	else
		printf("%d, ", theInstruction->rInput2);

	if ( theInstruction->rInput3 == NoRegister )
		printf("*> : ");
	else
		printf("%d> : ", theInstruction->rInput3);

	// replaced by the mess up above
	//printf("<%d, %d> <- ", theInstruction->rOutput1, theInstruction->rOutput2);
	//printf("<%d, %d, %d> : ", theInstruction->rInput1, theInstruction->rInput2, theInstruction->rInput3);

	printf("[msi%d,ifq%d,e%d,d%d,me%d,md%d] ",
		theInstruction->MisSpeculatedInstruction,
		theInstruction->InFireQueue,
		theInstruction->Executed, theInstruction->Dispatched,
		theInstruction->MemoryExecuted, theInstruction->MemoryDispatched);
	if(theInstruction->CurrentProcessorStage)
		printf(" in %s\n", theInstruction->CurrentProcessorStage->GetName());
	else
		printf(" not sure where it is\n");
	return(1);
	}	
		


