class	CompletionStage;
class	StoreBuffer;

class	ExecutionStage	:
	public	ProcessorStage
	{
	public:
		int						MaxExecutePerCycle;
		int						MaxIntegerExecutionCores;
		int						MaxFloatingPointExecutionCores;
		Array<Instruction*>		IntegerExecutionCores;
		Array<Instruction*>		FloatingPointExecutionCores;
		FetchStage				*theFetchStage;
		RenameStage				*theRenameStage;
		RegisterAccessStage		*theRegisterAccessStage;
		StoreBuffer				*theStoreBuffer;
		CompletionStage			*theCompletionStage;

		virtual	~ExecutionStage() {};

		static	bool	BindParameters(ExecutionStage	*This, TupleSpace	*theTupleSpace, char	*aName = NULL);

			bool	BindStructures(
						FetchStage				*aFetchStage,
						RenameStage				*aRenameStage,
						RegisterAccessStage		*aRegisterAccessStage,
						StoreBuffer				*aStoreBuffer,
						CompletionStage			*aCompletionStage);

			int		SimulateOneCycle();
			bool	FlushSpeculativeState();

			bool	PrintDebuggingInformation(FILE	*fp, int	Level);
	};

