#	include	"Standard.h"


bool
GShareBranchPredictor	::	BindParameters(GShareBranchPredictor	*This, TupleSpace	*theTupleSpace)
	{
	theTupleSpace->StartSubSpace("GShareBranchPredictor");
	SetComponentName(This, theTupleSpace);
	theTupleSpace->Bind(Parameter(This, ShiftRightProgramCounter), 2);
	theTupleSpace->Bind(Parameter(This, ShiftLeftProgramCounter), 0);
	theTupleSpace->Bind(Parameter(This, ShiftRightHistory), 0);
	theTupleSpace->Bind(Parameter(This, ShiftLeftHistory), 6);
	theTupleSpace->Bind(Parameter(This, TableSize), 1024);
	theTupleSpace->Bind(Parameter(This, CounterBits), 2);
	theTupleSpace->EndSubSpace();
	return(true);
	}

bool
GShareBranchPredictor	::		BindStructures()
	{
	MaxCounter = (1 << (CounterBits-1)) - 1;
	MinCounter = -1*MaxCounter  - 1;

	Counters = new int[TableSize];
	memset(Counters, 0, sizeof(int)*TableSize);

	Mask = TableSize - 1;

	BranchPredictor::Initialize();

	return ( true );
	}

BranchOutcome
GShareBranchPredictor	::	MakePrediction(
	Instruction	*aInstruction)
	{
	uint64	theProgramCounter = aInstruction->ProgramCounter;
	uint64	theHistory = BranchHistory;

	theProgramCounter = theProgramCounter >> ShiftRightProgramCounter;
	theProgramCounter = theProgramCounter << ShiftLeftProgramCounter;
	// yes this is in the opposite order
	theHistory = theHistory << ShiftLeftHistory;	
	theHistory = theHistory >> ShiftRightHistory;	

	int	theIndex = (int)((theProgramCounter ^ theHistory) & Mask);

	aInstruction->BranchIndex1 = theIndex;

	if ( Counters [ theIndex ] >= 0 )	// taken
		{
		BranchHistory = (BranchHistory << 1) | 0x00;

		//printf("taken\n");
		if ( aInstruction->RealBranchOutcome != Taken )
			++MisPredictions;
		else
			++CorrectPredictions;

		return ( Taken );
		}

	if ( aInstruction->RealBranchOutcome != NotTaken )
		++MisPredictions;
	else
		++CorrectPredictions;

	BranchHistory = (BranchHistory << 1) | 0x01;
	return ( NotTaken );
	}

bool
GShareBranchPredictor	::	UpdateState(
	Instruction	*aInstruction)
	{
	if ( aInstruction->RealBranchOutcome == Taken )
		{
		if ( Counters [ aInstruction->BranchIndex1 & Mask ] < MaxCounter )
			++Counters [ aInstruction->BranchIndex1 & Mask ];
		}
	else
		{
		if ( Counters [ aInstruction->BranchIndex1 & Mask] > MinCounter )
			--Counters [ aInstruction->BranchIndex1 & Mask];
		}
	return ( true );
	}

bool
GShareBranchPredictor	::	EnterSpeculativeState (
	uint64	MisSpeculatedInstruction)
	{
	nscBranchHistory = BranchHistory;
	return(true);
	}

bool
GShareBranchPredictor	::	FlushSpeculativeState ()
	{
	//BranchHistory = nscBranchHistory ^ cuint64(1);
	return(true);
	}

