class	CompletionStage;
class	StoreBuffer;

class	IssueWindowStage	:
	public	ProcessorStage
	{
	public:
		int						IssueWindowSize;
		int						InstructionsInFlight;
		int						PhysicalRegisterFileSize;
		int						MaxDispatchPerCycle;
		FetchStage				*theFetchStage;
		RenameStage				*theRenameStage;
		StoreBuffer				*theStoreBuffer;
		CompletionStage			*theCompletionStage;
		Array<int>				RegisterValidStates;

		uint64					MisSpeculatedInstruction;	
		// optimizations to make life fast
		PQueueOfPtr<Instruction *>	ReadyToFire;
		Array<Instruction	*>		*NotReadyToFire;

			virtual	~IssueWindowStage() {};

		static	bool	BindParameters(IssueWindowStage	*This, TupleSpace	*theTupleSpace, char	*aName = NULL);
		bool	BindStructures(
						FetchStage	*aFetchStage,
						RenameStage	*aRenameStage,
						StoreBuffer	*aStoreBuffer,
						CompletionStage	*aCompletionStage);

			int		SimulateOneCycle();	

			bool	AcquireFrom(Instruction	**, int	OfType = InstructionTypeAll);

			bool	PeekAt(Instruction	**, int	OfType = InstructionTypeAll);

			bool	WriteBackRegister(int	Number);
			bool	NotifyAboutRegisterRename(int	Number);
			inline	bool	IsRegisterValid(int	Number)
				{
				if ( (Number == ZeroRegister) || (Number == NoRegister))		// zero is always valid
					return ( true );
				if ( RegisterValidStates[Number] )
					return ( true );
				return ( false );
				}

			bool	EnterSpeculativeState(uint64	aMisSpeculatedinstruction);
			bool	FlushSpeculativeState();

			bool	PrintDebuggingInformation(FILE	*fp, int	Level);
	};


