typedef	struct	_RegisterWriteUpdate
	{
	int	UpdateAt;
	int	Register1;
	int	Register2;
	}	RegisterWriteUpdate;

class	RegisterAccessStage	:
	public	ProcessorStage
	{
	public:
		virtual	bool	WriteBackRegister(int)	{	return(true);	}
	};

class	NonBypassingRegisterAccessStage	:
	public		RegisterAccessStage
	{
	public:
		Fifo<Instruction	*>	ReadyToFire[InstructionTypes];
		int						MaxDispatchPerCycle;
		int						MaxInstructionsInFlight;
		int						InstructionsInFlight;
		RenameStage				*theRenameStage;
		IssueWindowStage		*theIssueWindowStage;
		CompletionStage			*theCompletionStage;
		Array<RegisterWriteUpdate>	NotificationList;
	public:
		virtual	~NonBypassingRegisterAccessStage()	{};

		static	bool	BindParameters(NonBypassingRegisterAccessStage	*This, TupleSpace	*theTupleSpace, char	*aName = NULL);

			bool	BindStructures(
						RenameStage	*aRenameStage,
						IssueWindowStage	*aIssueWindowStage,
						CompletionStage		*aCompletionStage);

			int		SimulateOneCycle();	

			bool	AcquireFrom(Instruction	**, int	OfType = InstructionTypeAll);
			bool	PeekAt(Instruction	**, int	OfType = InstructionTypeAll);
			bool	WriteBackRegister(int	Number);
			bool	FlushSpeculativeState();
	};

class	BypassingRegisterAccessStage	:
	public	RegisterAccessStage
	{
	public:
		int						ByPassListSize;
		int						InstructionsInFlight;
		int						PhysicalRegisterFileSize;
		int						MaxDispatchPerCycle;
		RenameStage				*theRenameStage;
		IssueWindowStage		*theIssueWindowStage;
		CompletionStage			*theCompletionStage;
	
		// optimizations to make life fast
		PQueueOfPtr<Instruction *>	ReadyToFire[InstructionTypes];
		Array<Instruction	*>		*NotReadyToFire;
		Array<RegisterWriteUpdate>	NotificationList;

			virtual	~BypassingRegisterAccessStage() {};

		static	bool	BindParameters(BypassingRegisterAccessStage	*This, TupleSpace	*theTupleSpace, char	*aName = NULL);

			bool	BindStructures(
						RenameStage	*aRenameStage,
						IssueWindowStage	*aIssueWindowStage,
						CompletionStage		*aCompletionStage);
			bool	PrintDebuggingInformation(
						FILE	*fp,
						int		Level);

			int		SimulateOneCycle();	

			bool	AcquireFrom(Instruction	**, int	OfType = InstructionTypeAll);

			bool	PeekAt(Instruction	**, int	OfType = InstructionTypeAll);

			bool	WriteBackRegister(int	Number);

			bool	FlushSpeculativeState();
	};


