
class	PhysicalRegister
	{
	public:
		int		Number;
		int		Valid;
		int		PendingUses;
		bool	PartOfArchitectureState;
		int		ArchitectureRegister;
		bool	IsFree;
	};

class	IssueWindowStage;

class	RenameStage	:
	public	ProcessorStage
	{
	public:
		Fifo<PhysicalRegister	*>		FreeList;
		int								PhysicalRegisterFileSize;
		Array<PhysicalRegister	*>		ArchitectureRegisterFile;
		Fifo<Instruction		*>		DecodedInstructions;
		int								MaxDecodePerCycle;
		FetchStage						*theFetchStage;
		IssueWindowStage				*theIssueWindowStage;
		Array<PhysicalRegister	*>		PhysicalRegisterFile;

		// these are supporting speculation.
		int								*nscRegisterMap;
		bool							WillGoSpeculative;
		uint64							WatchForThisSpeculativeInstruction;

			virtual	~RenameStage() {};

			static	bool	BindParameters(RenameStage	*This, TupleSpace	*theTupleSpace, char	*aName = NULL);
			bool	BindStructures(FetchStage	*aFetchStage, IssueWindowStage	*aIssueWindowStage);

			int		SimulateOneCycle();

			bool	PeekAt(Instruction	**, int	OfType = InstructionTypeAll);

			bool	AcquireFrom(Instruction	**, int	OfType = InstructionTypeAll);

			bool	AddToFreeList(int	Number);

			bool	WriteBackRegister(int	Number);

			bool	NotifyAboutRegisterUse(int	Number);

			inline	bool	IsRegisterValid(int	Number)
				{
				if ( (Number == ZeroRegister)||(Number == NoRegister) )
					return ( true );
				if ( PhysicalRegisterFile[Number]->Valid )	// are we valid?
					return ( true );
				return ( false );
				}

			bool	nscIsRegisterValid(int	Number);

			bool	EnterSpeculativeState(uint64	MisSpeculatedInstruction);
			bool	FlushSpeculativeState();
		};

