class	StoreBufferEntry	:
	public	HashableObject
	{
	public:
		Instruction	*theInstruction;
		bool		StrictComparison;
	public:
		int		HashCode(int	Max)
			{
			return(theInstruction->MemoryAddress % Max);
			}
		bool	IsEqual(HashableObject	*aca)
			{
			StoreBufferEntry		*ca = (StoreBufferEntry *)aca;

			bool						Strict = false;
			if ( StrictComparison )		Strict = true;
			if ( ca->StrictComparison )	Strict = true;

			// determine the amount of address bits to worry about
			uint64					MaxSize = 1;
			if ( theInstruction->Operation == OpStore )
				MaxSize = theInstruction->MemoryTransactionSize;
			if ( ca->theInstruction->Operation == OpStore )
			if ( ca->theInstruction->MemoryTransactionSize > MaxSize)
				MaxSize = ca->theInstruction->MemoryTransactionSize;

			if ( Strict )
				{
				if ( ca->theInstruction == theInstruction )
					return ( true );
				return(false);
				}

			if(	(ca->theInstruction->MemoryAddress & (~(MaxSize-1))) ==
				(    theInstruction->MemoryAddress & (~(MaxSize-1)))	)
				{
				if(ca->theInstruction->Operation == OpStore)
				if(ca->theInstruction->LoadStoreSequence < theInstruction->LoadStoreSequence)
					return(true);
				if(theInstruction->Operation == OpStore)
				if(theInstruction->LoadStoreSequence < ca->theInstruction->LoadStoreSequence)
					return(true);
				}
			return(false);
			}
	};

	
class	StoreBuffer	:
	public	ProcessorStage
	{
	public:
		HashTable					*PendingStores;
		Array<Instruction	*>		OrderingArray;
		Fifo<uint64>				ReturnBackFromMemorySystem;
		Fifo<MemoryTransactionMessage	*>	SendToMemorySystem;
		Array<RegisterWriteUpdate>	NotificationList;

		int							StoreBufferSize;
		uint64						LoadStoreSequence;

		int							DispatchesThisCycle;
		int							RetiresThisCycle;
		int							IssuesThisCycle;
		int							MaximumDispatchesPerCycle;
		int							MaximumRetiresPerCycle;
		int							MaximumIssuesPerCycle;

		RenameStage					*theRenameStage;
		IssueWindowStage			*theIssueWindowStage;
		RegisterAccessStage			*theRegisterAccessStage;
		CompletionStage				*theCompletionStage;
		Component					*theMemorySystem;
		bool						WillGoSpeculative;
		uint64						WatchForThisSpeculativeLoadStoreSequence;
	public:
		static	bool	BindParameters(StoreBuffer	*This, TupleSpace	*theTupleSpace);
		bool	BindStructures(
					RenameStage			*aRenameStage,
					IssueWindowStage	*aIssueWindowStage,
					RegisterAccessStage	*aRegisterAccessStage,
					CompletionStage		*aCompletionStage,
					Component			*aMemorySystem);
		
		bool	DispatchTo(Instruction	*);
		bool	ReserveSpaceFor(Instruction	*);
		int		SimulateOneCycle();
		int		SimulateOneCyclePart2();
		bool	FlushSpeculativeState();
		bool	EnterSpeculativeState(uint64	MisSpeculatedInstruction);

		bool	PrintDebuggingInformation(FILE	*fp, int	Level);

		bool	ReceiveMessage(Component *, Message	*m);
		int		WhenCanYouTakeThisMessage(Component *, Message *) { return(0); }
	};

