class	SuperScalarProcessor	:
	public	Component
	{
	public:

		int					MachineWidth;
		int					WindowSize;

		Engine				*theEngine;

		FetchStage			*theFetchStage;
		DelayStage			*theDecodeStage;
		RenameStage			*theRenameStage;
		IssueWindowStage	*theIssueWindowStage;
		NonBypassingRegisterAccessStage	*theRegisterAccessStage;
		ExecutionStage		*theExecutionStage;
		CompletionStage		*theCompletionStage;
		StoreBuffer			*theStoreBuffer;

		Component			*theInstructionMemorySystem;
		Component			*theDataMemorySystem;

		Array<ProcessorStage	*>	ProcessorStageList;

		GShareBranchPredictor				*theBranchPredictor;
		SetAssociativeBranchTargetBuffer	*theBranchTargetBuffer;

	public:
				SuperScalarProcessor();
				~SuperScalarProcessor();

		static	bool	BindParameters(SuperScalarProcessor	*This, TupleSpace	*theTupleSpace, char	*aName = NULL);
		bool	Create();
		bool	BindStructures (
					TupleSpace	*theTupleSpace,
					Engine		*aEngine,
					Component	*aInstructionMemorySystem,
					Component	*aDataMemorySystem);

		int		SyncSimulateOneCycle();

		bool	PrintStatistics(OutputFormat, FILE *);

		bool	PrintDebuggingInformation( FILE	*fp, int		Level);
	};
