class	SingleProcessorSystemBoard	:
	public	Component
	{
	public:

		uint64					MasterClockFrequency;		// in cycles/second -- usually this is the processor clock
		uint64					FastForwardAmount;
		uint64					WarmUpAmount;
		uint64					SimulateAmount;	
		SuperScalarProcessor	*theProcessor;
		SimpleCacheMemorySystem	*theMemory;
		Engine					*theEngine;
		Domain					*theDomain;
		
		static	bool	BindParameters(SingleProcessorSystemBoard	*This, TupleSpace	*theTupleSpace, char	*aName = NULL);
				bool	Create();
				bool	BindStructures(TupleSpace	*theTupleSpace, Engine	*aEngine);
				bool	PrintStatistics(OutputFormat, FILE *);
				bool	Initialize(TupleSpace	*theTupleSpace, Engine	*aEngine);
				bool	FastForward(uint64	nInstructions);
				bool	WarmUp(uint64	nInstructions);
				bool	Simulate(uint64	nInstructions);		// 0 for until finished

				bool	DoSimulation();
	};
