#	include	"Standard.h"

DEFINE_ALLOCATOR(HashedObject);

HashedObject	::	HashedObject ()
	{
	Object = NULL;
	Next = NULL;
	}

HashedObject	::	~HashedObject ()
	{
	if ( Object )
		delete Object;
	if ( Next )
		delete Next;
	}

HashedObject	*
HashedObject	::	Chain (
	HashedObject	*HO )
	{
	Next = HO;
	return(this);
	}

typedef	HashedObject	*HashedObjectPtr;

HashTable	::	HashTable(
	int		theSize,
	bool	DeleteOnEnd )
	{
	theHashTable = new HashedObjectPtr[theSize];
	HashTableSize = theSize;

	int	Index = 0;
	while ( Index < HashTableSize )
		{
		theHashTable [ Index ] = NULL;
		++Index;
		}
	DeleteObjects = DeleteOnEnd;
	Valid = 0;
	}

HashTable	::	~HashTable ()
	{
	if ( theHashTable )
		{
		int	Index = 0;
		while ( Index < HashTableSize )
			{
			if ( ! DeleteObjects )
				{
				HashedObject	*HO = theHashTable[Index];
				while ( HO )
					{
					HO->Object = NULL;
					HO = HO->Next;
					}
				}	
			if ( theHashTable [ Index ] )
				delete theHashTable [ Index ];
			theHashTable [ Index ] = NULL;
			++Index;
			}
		delete theHashTable;
		theHashTable = NULL;
		}
	}


bool
HashTable	::	InsertObject (
	HashableObject	*theHO )
	{
	HashedObject	*HOM = NEW(HashedObject);
	HOM->Connect(theHO);
	int		Code = theHO->HashCode(HashTableSize)%HashTableSize;

	//HashTable[Code] = HOM->Chain(HashTable[Code]);
	HOM->Next = theHashTable[Code];
	theHashTable[Code] = HOM;
	++Valid;
	return ( true );
	}

bool
HashTable	::	RemoveObject (
	HashableObject	*theHO )
	{
	int		Code = theHO->HashCode(HashTableSize)%HashTableSize;

	HashedObject	*HO = theHashTable[Code];
	HashedObject	*OldHO = NULL;

	while ( HO )
		{
		if ( HO->Object->IsEqual(theHO) )
			{
			// Found it.
			if ( ! OldHO )
				theHashTable[Code] = HO->Next;
			else
				OldHO->Next = HO->Next;
			if ( DeleteObjects )
				if ( HO->Object )
					delete HO->Object;
			HO->Next = NULL;
			HO->Object = NULL;
			DELETE(HashedObject, HO);
			--Valid;
			return ( true );
			}
		OldHO = HO;
		HO = HO->Next;
		}	
	return ( false );
	}

HashableObject	*
HashTable	::	LocateObject (
	HashableObject	*theHO )
	{
	int		Code = theHO->HashCode(HashTableSize)%HashTableSize;

	HashedObject	*HO = theHashTable[Code];

	while ( HO )
		{
		if ( HO->Object->IsEqual(theHO) )
			{
			return ( HO->Object );
			}
		HO = HO->Next;
		}	
	return ( NULL );
	}

bool
HashTable	::	StartIterator()
	{
	CurrentIndex = 0;
	CurrentSubIndex = theHashTable[CurrentIndex];
	return(true);
	}

HashableObject	*
HashTable	::	Next()
	{
	while(!CurrentSubIndex)
		{
		++CurrentIndex;
		if(CurrentIndex>=HashTableSize)
			return(NULL);
		CurrentSubIndex = theHashTable[CurrentIndex];
		}
	HashedObject	*HO = CurrentSubIndex;
	CurrentSubIndex = CurrentSubIndex->Next;
	return(HO->Object);
	}


