union	TupleUnion
	{
	byte	Asbyte;
	uint	Asuint;
	int		Asint;
	uint64	Asuint64;
	int64	Asint64;
	bool	Asbool;
	char	*Asstring;
	};

class	Tuple	:
	public	HashableObject
	{
	public:
		TupleUnion	theTuple;
		Type		theType;
		char		*Name;
		bool		Debug;
		bool		Touched;

	public:
		Tuple()	{	Name = NULL; theType = typeInteger; Debug = false; Touched = false;};
	
		Tuple(int v) {Tuple(); Set(v); }
		Tuple(bool v) {Tuple(); Set(v); }
		Tuple(uint64 v) {Tuple(); Set(v); }
		Tuple(char *v) {Tuple(); Set(v); }

		Tuple(char *n, int v) {Tuple(); SetName(n); Set(v); }	
		Tuple(char *n, bool v) {Tuple(); SetName(n); Set(v); }
		Tuple(char *n, uint64 v) {Tuple(); SetName(n); Set(v); }
		Tuple(char *n, char *v) {Tuple(); SetName(n); Set(v); }

		void	SetDebug(bool	v = true) { Debug = v; }
		bool	GetDebug() { return ( Debug ); }
		void	SetTouched(bool v = true) { Touched = v; }
		bool	GetTouched() { return ( Touched ); }

		char	*GetName()	{	return(Name); }

		void	SetName(char *n)
			{
			if(Name) delete Name;
			Name = new char[strlen(n)+1];strcpy(Name, n);
			}
		void	Set(int v)
			{
			if(theType == typeString && theTuple.Asstring) delete theTuple.Asstring;
			theTuple.Asint = v; theType = typeInteger;
			}
		void	Set(bool v)
			{
			if(theType == typeString && theTuple.Asstring) delete theTuple.Asstring;
			theTuple.Asbool = v; theType = typeBool;
			}
		void	Set(uint64 v)
			{
			if(theType == typeString && theTuple.Asstring) delete theTuple.Asstring;
			theTuple.Asuint64 = v; theType = typeuInt64;
			}
		void	Set(char *n)
			{
			if(theType == typeString && theTuple.Asstring) delete theTuple.Asstring;
			theTuple.Asstring = new char[strlen(n)+1];
			strcpy(theTuple.Asstring, n); theType = typeString;
			}
		void	Set(Tuple	*t)
			{
			switch(t->GetType())
				{
				case	typeInteger:	Set(t->GetInteger());	break;
				case	typeBool:		Set(t->GetBool());		break;
				case	typeuInt64:		Set(t->GetuInt64());	break;
				case	typeString:		Set(t->GetString());	break;
				default:
					break;
				}
			}

		Type	GetType()	{	return ( theType ); };

		int		GetInteger()	{	return(theTuple.Asint); }
		bool	GetBool()		{	return(theTuple.Asbool);	};
		uint64	GetuInt64()		{	return(theTuple.Asuint64);	};
		char	*GetString()	{	return(theTuple.Asstring);	};

		void	*GetPtr()
			{
			switch(GetType())
				{
				case	typeInteger:	return(&theTuple.Asint);
				case	typeBool:		return(&theTuple.Asbool);
				case	typeuInt64:		return(&theTuple.Asuint64);
				case	typeString:		return(theTuple.Asstring);
				default:
					return(NULL);
				}
			}

		int		HashCode(int)
			{
			if(!Name)return(0);
			int	v = 0;
			char	*n = Name;
			while(*n)
				{
				v = (int)(v * 1.2);
				v = v + (*n);
				++n;
				}
			return(v);
			}
		bool	IsEqual(HashableObject	*HO)
			{
			Tuple	*t = (Tuple*)HO;
			if ( !Name)	return(false);
			if ( ! t->Name)	return(false);
			if(!strcmp(Name, t->Name))	return(true);
			return(false);
			}
	};


// DEFINE_ALLOCATOR(Tuple)

class	TupleSpace
	{
	HashTable	theTupleSpace;

	Stack<Tuple	*>	SubSpaces;
	Array<Tuple	*>	TupleList;

	public:
		TupleSpace()	:
			theTupleSpace(511, false)
			{
			}

		bool	StartSubSpace(char	*Name);
		bool	EndSubSpace();
		bool	BuildFullName(char *, char *);
		char	*CurrentSpace(char *);
		Tuple	*LocateCloseMatch(char *);
#	define	DeclareBindFunction(ttt)	\
		bool	Bind(ttt	*Value, char	*name, char	*Default0, ttt	Default1);	\
		bool	Bind(ttt	*Value, char	*name, char	*Default0)	{ return(Bind(Value, name, Default0, (ttt)0)); }	\
		bool	Bind(ttt	*Value, char	*name, ttt	Default1)	{ return(Bind(Value, name, NULL, Default1)); }	\
		bool	Bind(ttt	*Value, char	*name)					{ return(Bind(Value, name, NULL, (ttt)0)); }
#	define	DeclareBindFunction2(ttt)	\
		bool	Bind(ttt	*Value, char	*name, char	*Default0, ttt	Default1);	\
		bool	Bind(ttt	*Value, char	*name, ttt	Default1)	{ return(Bind(Value, name, NULL, Default1)); }	\
		bool	Bind(ttt	*Value, char	*name)					{ return(Bind(Value, name, NULL, (ttt)0)); }

		DeclareBindFunction(int);
		DeclareBindFunction(uint64);
		DeclareBindFunction(bool);
		DeclareBindFunction2(char*);	
		CommandLineArgument	*GetCommandLineArguments();
	};

#	define	Parameter(ccc, xxx)		(ccc ? (&ccc->xxx) : NULL), #xxx
#	define	StaticPass(ccc, xxx)	(ccc ? (ccc->xxx) : NULL)
#	define	DefaultPass(ccc, xxx)	(ccc ? (char*)ccc : (char*)xxx)
#	define	SetComponentName(ccc, xxx)	{char sss[1024]; if (ccc) ccc->SetName(xxx->CurrentSpace(sss));}
