#	include	"Standard.h"


extern	"C"	int	main(int	argc, char	*argv[], char	*argp[]);

extern	char	StandardConfig[];

int
runtest(bool	debug, char	*foo, char	**argv)
	{
	AlphaProcessor	*ap = new AlphaProcessor;

	ap->Initialize(foo, argv, NULL);
	ap->Test(false);
	return(0);
	}

int
main(
	int		argc,
	char	*argv[],
	char	*argp[])
	{
//	runtest(atoi(argv[1]), argv[1], &argv[1]);
//	exit(1);
	bool		Quiet = false;	
	char		*OutputStatisticsFilePtr = "stat.log";

	AlphaProcessor			*theEngine = new AlphaProcessor;
	SingleProcessorSystemBoard	*theSystem = new SingleProcessorSystemBoard;
	TupleSpace				*theConfigurationSpace = new TupleSpace;
 
	theConfigurationSpace->Bind(NULL, "Quiet", (bool)false);
	theConfigurationSpace->Bind((char**)NULL, (char*)"OutputStatisticsFile", (char*)"stat.log");

	theSystem->BindParameters(NULL, theConfigurationSpace);
	CommandLineArgument	*cla = theConfigurationSpace->GetCommandLineArguments();

	ParseString(cla, StandardConfig, 2);	// be silent about any errors
	int	newargc = ParseCommandLine(cla, argc, argv, 0);

	theConfigurationSpace->Bind(&Quiet, "Quiet");
	theConfigurationSpace->Bind(&OutputStatisticsFilePtr, "OutputStatisticsFile");

	if ( ! Quiet ) Banner(stdout);

	if ( newargc == argc )
		{
		printf("usage: %s [options] prog [args]\n\n\tuse -h to see list of options\n", argv[0]);
		exit(1);
		}

	if ( ! theEngine->Initialize(argv[newargc], &argv[newargc], NULL) )
		FatalError("Could not initialize instruction engine");

	theSystem->Initialize(theConfigurationSpace, theEngine);

	// save the parameters that were actually used
	//FILE	*fp1 = fopen("config.out", "w");
	//DumpParameters(cla, fp1);
	//fclose(fp1);

	time_t	StartAtTime = time(NULL);
	theSystem->DoSimulation();
	time_t	EndAtTime = time(NULL);
	time_t	TotalTime = EndAtTime - StartAtTime;

	// save the parameters that were used and the statistics
	// Note: this format is specially crafted such that it can be easilly transformed into
	// a configuration file.  Infact, it can be read directly with a -Source: option.  However,
	// the preferred method is to trim out the statistics and header information from configuration
	// files.

	FILE	*fp = fopen(OutputStatisticsFilePtr, "w");
	fprintf(fp, "# simulation started at: " format_dec_uint64 ": %s", (uint64)StartAtTime, ctime(&StartAtTime));
	fprintf(fp, "#   simulation ended at: " format_dec_uint64 ": %s", (uint64)EndAtTime, ctime(&EndAtTime));
	fprintf(fp, "#   simulation time was: " format_dec_uint64 " seconds\n", (uint64)TotalTime);
	fprintf(fp, "# simulation rate was: " format_dec_int64 " cycles/second\n", (int64)(((double)theSystem->theDomain->GetCurrentCycle())/((double)TotalTime)));
	fprintf(fp, "#\n");
	fprintf(fp, "# program: ");
	int	Index = newargc;
	while ( Index < argc )
		{
		fprintf(fp, "%s ", argv[Index]);
		++Index;
		}
	fprintf(fp, "\n");
	fprintf(fp, "#########################################################################################\n");
	fprintf(fp, "# simulated configuration follows\n");
	fprintf(fp, "#########################################################################################\n");
	fprintf(fp, "#\n");
	DumpParameters(cla, fp);
	fprintf(fp, "#\n");
	fprintf(fp, "#########################################################################################\n");
	fprintf(fp, "# output statistics follows\n");
	fprintf(fp, "#########################################################################################\n");
	fprintf(fp, "#\n");
	theSystem->PrintStatistics(HumanFormat, fp);
	fclose(fp);
	return(0);
	}

